//
//  MasterViewController.swift
//  PhotoAlbum
//
//  Created by Merlyn on 12/16/14.
//  Copyright (c) 2014 The App Lady. All rights reserved.
//

import UIKit

class MasterViewController: UITableViewController {

    //var objects = NSMutableArray()
    var detailViewController: DetailViewController? = nil
   
    // tableView dataSource objects
    var tableDataSource = [String]()
    var plistData = [[String]]()
    var albumList = [String]()
    var photoList = [[String]]()
    
    override func awakeFromNib() {
        super.awakeFromNib()
        if UIDevice.currentDevice().userInterfaceIdiom == .Pad {
            self.clearsSelectionOnViewWillAppear = false
            self.preferredContentSize = CGSize(width: 320.0, height: 600.0)
        }
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        if let split = self.splitViewController {
            let controllers = split.viewControllers
            self.detailViewController = controllers[controllers.count-1].topViewController as? DetailViewController
        }
        
        // Initialize the tableView's dataSource objects
        plistData = fetchPlistData()
        albumList = plistData.removeLast()
        photoList = plistData
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Segues

    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        if segue.identifier == "showDetail" {
            if let indexPath = self.tableView.indexPathForSelectedRow() {
                let controller = (segue.destinationViewController as UINavigationController).topViewController as DetailViewController
                controller.navigationItem.leftBarButtonItem = self.splitViewController?.displayModeButtonItem()
                controller.navigationItem.leftItemsSupplementBackButton = true
                
                // Pass the photoUrls for the selectedAlbumName to the PhtoDetailViewController
                var selectedAlbumName = albumList[indexPath.row]
                if selectedAlbumName == "Actors" {
                    controller.cvDataSource = photoList[indexPath.row]
                    controller.selectedAlbumName = selectedAlbumName
                    
                } else if selectedAlbumName == "Animals" {
                    controller.cvDataSource = photoList[indexPath.row]
                    controller.selectedAlbumName = selectedAlbumName
                    
                } else if selectedAlbumName == "Flowers" {
                    controller.cvDataSource = photoList[indexPath.row]
                    controller.selectedAlbumName = selectedAlbumName
                    
                } else if selectedAlbumName == "Other" {
                    controller.cvDataSource = photoList[indexPath.row]
                    controller.selectedAlbumName = selectedAlbumName
                }
            }
        }
    }

    // MARK: - Table View

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // Return the number of sections there are in the table's dataSource object
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // Return the number of items in the section
        return albumList.count
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("Cell", forIndexPath: indexPath) as UITableViewCell

        // Put the current array element in a variable
        let albumName: String = albumList[indexPath.row]
        
        // Configure the collection view cell
        cell.textLabel!.text = albumName
        
        // Return the tableView cell
        return cell
    }

    func fetchPlistData() -> [[String]] {
        // Fetch data from the plist file and put it in an Obj-C dictionary
        let path = NSBundle.mainBundle().pathForResource("photos", ofType: "plist")
        var dictionary = NSDictionary(contentsOfFile: path!)!
        
        // Put the dictionary entries in a Swift Array
        var actors = dictionary["Actors"] as [String]
        var animals = dictionary["Animals"] as [String]
        var flowers = dictionary["Flowers"] as [String]
        var other = dictionary["Other"] as [String]
        
        // Put the dictionary keys in a Swift Array
        var albums = dictionary.allKeys as [String]
        
        // Put the albums array elements in alphabetical order
        var sortedAlbums = sorted(albums, { (s1: String, s2: String) -> Bool in
            return s1 < s2
        })
        
        // Put the dictonary entries and keys in a Swift Array
        var collection: Array = [actors, animals, flowers, other, sortedAlbums]
        
        /************* DEBUG CODE ***************
        println("The directory path is:\(path)\n-------------------------------\n")
        
        for entry in collection {
        for row in entry {
        println("\(row)")
        }
        }
        ****************************************/
        
        // Return plist data or an empty Swift Array
        return collection
    }

}

