//
//  PhotoViewController.swift
//  PhotoAlbum
//
//  Created by Merlyn on 12/17/14.
//  Copyright (c) 2014 The App Lady. All rights reserved.
//

import UIKit

class PhotoViewController: UIViewController {

    @IBOutlet weak var imageView: UIImageView!
    @IBOutlet weak var photoNameLabel: UILabel!
    var selectedPhotoUrl: String!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        imageView.image = self.getPhotoFromUrl(selectedPhotoUrl)
        var stringArray: Array =  selectedPhotoUrl.componentsSeparatedByString("/")
        var photoFile = stringArray.removeLast()
        var stringObjectArray = photoFile.componentsSeparatedByString(".")
        photoNameLabel.text = stringObjectArray[0]
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    // This function fetch a photo from the url passed to it as a parameter and returen it as an image object
    func getPhotoFromUrl(photoUrl:String) -> UIImage {
        //var err: NSError?
        var imgData = NSData()
        var unwrappedImage = UIImage()
        
        if var url = NSURL(string: photoUrl) {
            if let imgData = NSData(contentsOfURL:url) { // may return nil
                // Unwrap the raw data and put it in the unwrappedImage object
                unwrappedImage = UIImage(data:imgData)!
            }
        } else {
            if let url = NSURL(string:"http://theapplady.net/wp-content/uploads/2014/05/noimage.png") {
                if let imgData = NSData(contentsOfURL:url) { // may return nil
                    // Unwrap the raw data and put it in the unwrappedImage object
                    unwrappedImage = UIImage(data:imgData)!
                }
            }
        }
        // Return the image pass to the function as an argument or the image called noimage.png
        return unwrappedImage
    }

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
